# get operating system (for vars)
import os
import sys

# paths
javapath = os.getenv('JAVA_HOME')
# Expected: '/u01/app/jdk'
wlspath = os.getenv('WL_HOME')
# Expected: '/u01/app/fmw/wlserver'
numArgs = len(sys.argv)
#print "read %d arguments" % numArgs
#for arg in sys.argv:
#   print " arg = %s" % arg


if numArgs < 7:
    print("Error, missing arguments")
    print("Usage:")
    print("%s url target username password fully deployName fully_qualified_path_to_war" % sys.argv[0])
    print("for example")
    print("%s http:/localhost:7001 cluster1 SomeUser SomePwd benefits /tmp/benefits.war" % sys.argv[0])
    exit()

url = sys.argv[1]
target = sys.argv[2]
username = sys.argv[3]
password = sys.argv[4]
appname = sys.argv[5]
appsource = sys.argv[6]
#
# Python args are
# 0 - script name
# 1 - url to app server
# 2 - target (cluster1, "server1,server2")
# 3 - "weblogic" username
# 4 - "password" for #2
# 5 - name to deploy app as
# 6 fully qualifed path to application to deploy

print ("Attempting to deploy: %s(%s)to: %s using target(s): %s with credentials (%s,%s)."%(appname, appsource, url,target, username,password)) 

#
# Does file exist? Complain and exit if not
#
if not os.path.isfile(appsource):
    print("Error could not find %s." % appsource)
    print("Deploy failed.")
    exit()

# Connect to administration server
try:
    print("Attempting to connect to administration server at %s using (%s,%s)."%(url, username, password))
    connect(username, password, url)
except:
    print("Failed to connect to administration server at %s."%url)
    print("Check url, and credentials and try again")
    exit()

# Undeploy if its already there
try:
    print("Attempting undeploy %s if previously deployed."%appname)
    stopApplication(appname)
    progress = undeploy(appname)
    print("Undeploy successful")

except Exception:
    pass
    print("Application not found continuing.")



# the deploy command locks the config (and later activates) itself, 
# so do not start an edit session

# deploy app
print '>>>Deploying application ' + appsource + ' to target ' + target +'. Please wait.'
progress = deploy(appName=appname, path=appsource, targets=target)

# wait for deployment to finish
while progress.isRunning():
   pass

print '>>>Application ' + appname + ' deployed.'

# exit WLST
exit()

