#!/bin/bash

function usage() {

echo "Usage:"
echo "    $0 -a applicationName -p pathToApplication -U username"
echo "For Example:"
echo "    $0 -a benefits -p /tmp/benefits.war -U username"
echo "Optional arguments"
echo "    -u URL, default t3://localhost:7001"
echo "    -w WebLogic Server home, default /u01/app/fmw"
echo "    -t Target, default AdminServer"
echo "    -U User, default SomeUser"
#echo "    -P Password for user, default Somepassword"

}


if [ $# -lt 5 ]; then
    usage
else

URL="t3://localhost:7001"
installDIR=/u01/app/fmw

TARGET="AdminServer"
UNAME="SomeUser"
PWD=""
APPNAME=""
APPSOURCE=""

while getopts 'a:p:w:u:t:U:P:' opt; do
   case "${opt}" in
      P)
        PWD="$OPTARG"
        ;;

      U)
        UNAME="$OPTARG"
        ;;
      t)
        TARGET="$OPTARG"
        ;;
      
      w)
        installDIR="$OPTARG"
        ;;
      u)
        URL="$OPTARG"
        ;;
      a)
        APPNAME="$OPTARG"
        ;;
      p)
        #echo "processing p $OPTARG"
        APPSOURCE="$OPTARG"
        ;;
      \?)
        echo "Invalid option $OPTARG" 
        usage
        exit 1
        ;;
      :)
        echo "option -$OPTARG requires an argument"
        usage
        exit 1
        ;;
     
   esac
done

if [ -z "${PWD// }" ]; then

    echo "Weblogic Server administrator password required."
    stty -echo
    echo -e "Enter administrator password for user '$UNAME':"
    read PWD
    stty echo
fi

echo "deploy $APPNAME from $APPSOURCE to $URL to $TARGET using credentials $UNAME/********"


#source /u01/app/fmw/wlserver/server/bin/setWLSEnv.sh
source ${installDIR}/wlserver/server/bin/setWLSEnv.sh

java weblogic.WLST deploy.py $URL $TARGET $UNAME $PWD $APPNAME $APPSOURCE

fi
